%bcond_without check
%global debug_package %{nil}
%global __os_install_post %{_rpmconfigdir}/brp-compress
%global commitId 3d0ced9e9dd9d058a27e52c6b7f17c6e220f6dc3
%global python3_pkgversion 38

%global receptorctl_root %{name}-%{commitId}/receptorctl

Name:           receptor
Version:        1.0.0
Release:        1%{?dist}

%global common_description %{expand:
Project Receptor is a flexible multi-service relayer with remote execution and
orchestration capabilities linking controllers with executors across a mesh of
nodes.}

Summary:        Project Receptor is a flexible multi-service relayer with remote execution and orchestration capabilities linking controllers with executors across a mesh of nodes

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            https://github.com/ansible/receptor
Source0:        receptor-3d0ced9e9dd9d058a27e52c6b7f17c6e220f6dc3.tar.gz

BuildRequires: golang >= 1.14
BuildRequires: git >= 2.0

Requires: systemd

%description
%{common_description}

%package -n receptorctl
Summary:   Command line utility for Receptor
URL:       https://github.com/ansible/receptor
BuildArch: noarch

BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-pbr
BuildRequires: python%{python3_pkgversion}-rpm-macros
BuildRequires: python%{python3_pkgversion}-setuptools
Requires: python%{python3_pkgversion}
Requires: python%{python3_pkgversion}-setuptools
Requires: python%{python3_pkgversion}-dateutil
Requires: python%{python3_pkgversion}-click
Requires: python%{python3_pkgversion}-pyyaml

%description -n receptorctl
receptorctl is a command line utility for managing Receptor

%prep
%autosetup -n receptor-%{commitId}

# For receptorctl
echo %{version} > %{_builddir}/%{receptorctl_root}/.VERSION

cat > %{_builddir}/%{receptorctl_root}/PKG-INFO<<EOF
Metadata-Version: 1.0
Name: receptorctl
Version: %{version}
Summary: %{summary}
Author-email: info@ansible.com
License: UNKNOWN
Platform: UNKNOWN
EOF
cat %{_builddir}/%{receptorctl_root}/PKG-INFO

%build
# For receptor
go build -mod=vendor -ldflags "-X 'github.com/project-receptor/receptor/pkg/version.Version=%{version}'" -o ./receptor cmd/receptor.go
./receptor --bash-completion > receptor.completion

# For receptorctl
cd %{_builddir}/%{receptorctl_root}
%{__python3} setup.py build

%install
# For receptor
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp receptor            %{buildroot}%{_bindir}/receptor
install -m 0755 -vd                     %{buildroot}%{_sysconfdir}/systemd/system
install -m 0644 -vp packaging/rpm/receptor.service %{buildroot}%{_sysconfdir}/systemd/system/receptor@.service
install -m 0755 -vd                     %{buildroot}%{_sysconfdir}/receptor
install -m 0644 -vp packaging/rpm/receptor.conf.example %{buildroot}%{_sysconfdir}/receptor/receptor.conf.example
install -m 0755 -vd                     %{buildroot}%{_datadir}/bash-completion/completions
install -m 0644 -vp receptor.completion %{buildroot}%{_datadir}/bash-completion/completions/receptor

# For receptorctl
cd %{_builddir}/%{receptorctl_root}
%{__python3} setup.py install --single-version-externally-managed -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES
PYTHONPATH=$RPM_BUILD_ROOT/%{python3_sitelib} _RECEPTORCTL_COMPLETE=source_bash $RPM_BUILD_ROOT/usr/bin/receptorctl > %{_builddir}/%{receptorctl_root}/receptorctl-completion || true
install -m 0755 -vd %{buildroot}%{_datadir}/bash-completion/completions
install -m 0644 -vp %{_builddir}/%{receptorctl_root}/receptorctl-completion %{buildroot}%{_datadir}/bash-completion/completions/receptorctl

%clean
rm -rf $RPM_BUILD_ROOT

%files
%{_bindir}/receptor
%{_datadir}/bash-completion/completions/receptor
%{_sysconfdir}/receptor/receptor.conf.example
%{_sysconfdir}/systemd/system/receptor@.service

%files -n receptorctl -f %{_builddir}/%{receptorctl_root}/INSTALLED_FILES
%{_datadir}/bash-completion/completions/receptorctl
%defattr(-,root,root)

%changelog
* Mon Jun 28 2021 Satoe Imaishi <simaishi@redhat.com> - 1.0.0-1
- Receptor 1.0.0-1
